#define KEY	 0x0000DEAD   
#define CONFIG   "/etc/sitewho.conf"
#define GLGROUP "/etc/group"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <syslog.h>
#include <unistd.h>
#include <sys/param.h>
#include <fcntl.h>
#include <sys/stat.h>

struct ONLINE
{
  char   tagline[64];
  char   username[24];
  char   status[256];
  char   host[256];
  char   currentdir[256];
  long   groupid;
  time_t login_time;
  struct timeval tstart;   
  unsigned long bytes_xfer; 
  pid_t  procid;
};

static char mpath[4096];
static char ALTERGLGROUP[4096];
static char hiddenusers[4096];
static char glrootpath[256];
static char footer[4096];
static char header[4096];
static char piduser[24];
static int  MAXUSERS = 0;
static int  showhidden = 0;
static int  shownormal = 1;
static char USERNAME[24];

static struct ONLINE *online;
static double dlspeed = 0;
static double ulspeed = 0;
static int  dl = 0;
static int  ul = 0;
static int  num_users = 0;
static int  shmid;
static struct shmid_ds ipcbuf;

static void quit();
static double calc_time();


static char *
trim( char *str )
{
  char *ibuf;
  char *obuf;

  if ( str )
    {
      for ( ibuf = obuf = str; *ibuf; )
        {
          while ( *ibuf && ( isspace ( *ibuf ) ) )
          ibuf++;
          if ( *ibuf && ( obuf != str ) )
            *( obuf++ ) = ' ';
          while ( *ibuf && ( !isspace ( *ibuf ) ) )
            *( obuf++ ) = *( ibuf++ );
        }
      *obuf = '\0';
    }
  return( str );
}

/* # of printable chars in string */
int printchars(char *strin) {
 int cnt = 0;
 while ( isprint(strin[cnt]) ) cnt++;
 return cnt;
}


/* check if instr matches with any of the variables in sfrom */
int matchdir(char *instr, char *sfrom) {
 char directory[4096], directory2[4096];
 int cnt; 

 strcpy(directory2, sfrom);
 strcpy(directory, strtok(directory2, " "));
 if ( strncmp(directory, instr, strlen(directory)) == 0) return 1;

 while ( sprintf(directory, strtok(NULL, " ")) > 0 ) 
  if ( strncmp(directory, instr, strlen(directory)) == 0) return 1;
 return 0;
}


/* check if instr matches with any of the variables in sfrom */
int matchuser(char *instr, char *sfrom) {
 char username[4096], userarray[4096];
 int cnt; 

 strcpy(userarray, sfrom);
 strcpy(username, strtok(userarray, " "));
 if ( strcmp(username, instr) == 0) return 1;
 while ( sprintf(username, strtok(NULL, " ")) > 0 ) 
  if ( strcmp(username, instr ) == 0) return 1;
 return 0;
}



/* Read config */
void readconfig() {
 int fd, cnt, cnt2 = cnt = 0;
 char buffer[1];
 char data[3][4096];
 char flags[20];

 fd = open(CONFIG, O_NONBLOCK);
 if ( fd < 0 ) { printf("ERROR: Config file not found!\n"); exit(2); }

 if ( getenv("FLAGS") != NULL ) strcpy(flags, getenv("FLAGS"));
  else if ( shownormal ) strcpy(flags, "1ED"); 
  else flags[0] = '\0';

 while ( read(fd, buffer, 1) > 0 ) 
  if ( buffer[0] == '\n' ) { 
   data[cnt2][cnt++] = '\0';
   if ( data[1][0] == '=' ) {
    if ( ! strcmp(data[0], "glrootpath") ) strcpy(glrootpath, data[2]);
    else if ( ! strcmp(data[0], "maskeddirectories") ) strcpy(mpath, data[2]);
    else if ( ! strcmp(data[0], "hiddenusers") ) strcpy(hiddenusers, data[2]);
    else if ( ! strcmp(data[0], "headerfile") ) strcpy(header, data[2]);
    else if ( ! strcmp(data[0], "footerfile") ) strcpy(footer, data[2]);
    else if ( ! strcmp(data[0], "maxusers") ) MAXUSERS = strtol(data[2], (char **)NULL, 0);
    else if ( ! strcmp(data[0], "siteopseesall") && tolower(data[2][0]) == 'y' && strchr(flags, '1') != NULL ) showhidden = 1;
    else if ( ! strcmp(data[0], "killerseesall") && tolower(data[2][0]) == 'y' && strchr(flags, 'E') != NULL ) showhidden = 1;
    else if ( ! strcmp(data[0], "kickerseesall") && tolower(data[2][0]) == 'y' && strchr(flags, 'D') != NULL ) showhidden = 1;
   }
   cnt2 = cnt = 0; 
  } else if ( buffer[0] == ' ' && cnt2 < 2 ) { data[cnt2][cnt] = '\0' ; cnt2++ ; cnt = 0; }
    else data[cnt2][cnt++] = buffer[0];
 close(fd);
}

/* Search group file for groupid, if found return it as string */
char data[4][256];
char* groupname(int groupid) {
 int fd, cnt, cnt2 = cnt = 0;
 char buffer[1];
 if ( ALTERGLGROUP[0] != '\0' ) fd = open(ALTERGLGROUP, O_NONBLOCK);
                           else fd = open(GLGROUP, O_NONBLOCK);
 if ( fd < 0 ) return "NoGroup";

 while ( read(fd, buffer, 1) > 0 ) 
  if ( buffer[0] == '\n' ) { data[cnt2][cnt] = '\0'; if ( strtol(data[2], (char **)NULL, 0) == groupid) { close(fd); return data[0]; } cnt2 = cnt = 0; }
  else if ( buffer[0] == ':' && cnt2 < 3 ) { data[cnt2][cnt] = '\0' ; cnt2++ ; cnt = 0; }
  else data[cnt2][cnt++] = buffer[0];
 close(fd);
 return "NoGroup";
}

				 
static char hmsbuf[50];			
char* pid_hms_format( time_t testtime )
{
  time_t timenow = time( NULL );
  time_t difftime;
  int    days = 0;
  int    hours = 0;
  int    minutes = 0;
  int    seconds = 0;

  difftime = timenow - testtime;
   
  while ( difftime >= (time_t)3600 )
    {
      difftime -= (time_t)3600;
      hours++;
    }          
   
  while ( difftime >= (time_t)60 )
    {
      difftime -= (time_t)60;
      minutes++;
    }
   
  if ( hours != 0 )
    sprintf( hmsbuf, "%02d:%02d:%02d", hours, minutes, difftime );
  else
    sprintf( hmsbuf, "00:%02d:%02d", minutes, difftime );
  return hmsbuf;
}

struct stat fileinfo;
int filesize(char *filename) {
 int fd = open(filename, O_NONBLOCK);
 if ( fd != -1 ) {
   fstat(fd, &fileinfo);
   close(fd);
   if ( ! fileinfo.st_size ) return 1;
   return fileinfo.st_size;
 }
 close(fd);
 return 1;
}

static int
checkusers(void)
{
  register int i, j, k, found = 0;
  char statbuf[ 500 ];
  char pidbuf[ 10 ];
  char filename[16];
  char filelocation[500];
  int  mask;
  char username[17];
  char group[11];
  char tagline[27];
  char bar[18];
  char hiddenchar;
			
  for (i=0; i<num_users; i++) 
    { 
      if ( ! online[i].procid ) continue;
      hiddenchar = ' '; mask = 0;
      if ( ! strcasecmp(online[i].username, piduser) ) hiddenchar = '*';
       else { 
        if ( matchuser(online[i].username, hiddenusers) ) if ( ! showhidden ) continue;
                                                                         else hiddenchar = '*';
        if ( matchdir(online[i].currentdir, mpath ) ) if ( ! showhidden ) mask = 1;
                                                                     else hiddenchar = '*';
       }
      filename[0] = bar[0] = '\0';
      sprintf( pidbuf, "%u", online[i].procid );
      pid_hms_format( online[i].tstart.tv_sec );  
		
      if ((!strncasecmp (online[i].status, "STOR", 4) ||
	  !strncasecmp (online[i].status, "APPE", 4)) &&
          online[i].bytes_xfer != 0) {
          if ( ! mask ) {
           j = printchars(online[i].status + 5);

           strcat(filelocation, online[i].currentdir);
           strncat(filelocation, online[i].status + 5, j);

           if ( j > 15 ) strncpy(filename, online[i].status - 10 + j, 15);
                    else strncpy(filename, online[i].status + 5, j);
           if ( j < 15 ) filename[j] = '\0';
           filename[15] = '\0';
           sprintf( statbuf, "Up: %5.1fKbs", calc_time(i) );
           ulspeed += calc_time(i);
           sprintf(bar, "?->");
           ul++;
          } else {
           sprintf( statbuf, "Idle: %-8.8s", hmsbuf );
          }
        }
      /* Downloading */
      else if (!strncasecmp (online[i].status, "RETR", 4) && online[i].bytes_xfer != 0)
        {
          if ( ! mask ) {
           j = printchars(online[i].status + 5);
           if ( ALTERGLGROUP[0] != '\0' ) sprintf(filelocation, glrootpath);
                                     else filelocation[0] = '\0';
           strcat(filelocation, online[i].currentdir);
           for ( k = 0; k < online[i].bytes_xfer * 17 / filesize(filelocation) && k < 17 ; k++ ) bar[k] = '#';
           bar[k] = '\0'; 
 
           if ( j > 15 ) strncpy(filename, online[i].status - 10 + j, 15);
                    else strncpy(filename, online[i].status + 5, j);
           if ( j < 15 ) filename[j] = '\0';
           filename[15] = '\0';
           sprintf( statbuf, "Dn: %5.1fKbs", calc_time(i) );
           dlspeed += calc_time(i);
           dl++;
          } else {
           sprintf( statbuf, "Idle: %-8.8s", hmsbuf );
          }
        }
      /* Idling */
      else if (time(NULL) - online[i].tstart.tv_sec > 5)
        {
          sprintf( statbuf, "Idle: %-8.8s", hmsbuf );
        }
      /* Doing something else... */
      else
        {
          sprintf( statbuf, "Idle: %-8.8s", hmsbuf );
        }
      if ( shownormal ) {
       strncpy(username, online[i].username, 16); username[16] = '\0';
       strncpy(group, groupname(online[i].groupid), 10); group[10] = '\0';
       strncpy(tagline, online[i].tagline, 27); tagline[27] = '\0';
       printf("|%c%-16s/%-10s | %14s  | %% : %-17s |\n", hiddenchar, username, group, statbuf, bar);
       printf("| %-27s | since %8s  | file: %-15s |\n", tagline, pid_hms_format(online[i].login_time), filename);
       printf("+-----------------------------------------------------------------------+\n");
       found++; 
      } else if ( ! strcasecmp(USERNAME, online[i].username) ) {
       if ( found ) printf(" (%s: %s)", online[i].username, statbuf);
        else printf("(\002%s\002 - %s)", online[i].username, statbuf);
       found++; 
      }
    }
  return (found);
}

void showfile(char *filename) {
 int fd, j;
 char buffer[1025];
 char fname[4096];
 fname[0] = '\0';
 if ( ALTERGLGROUP[0] != '\0' ) strcpy(fname, glrootpath);
 strcat(fname, filename);
 fd = open(fname, O_NONBLOCK);
 if ( fd < 0 ) printf("+-----------------------------------------------------------------------+\n");
          else while ( (j = read(fd, buffer, 1024)) > 0 ) { buffer[j] = '\0' ; printf("%s", buffer); }
 close(fd);
}


int
main( int argc, char **argv )
{
  int numusers, fd;
  
  ALTERGLGROUP[0] = USERNAME[0] = piduser[0] = '\0';
  if ( argc > 1 ) { shownormal = 0; strcpy(USERNAME, argv[1]); }
   else if ( getenv("USER") != NULL ) strcpy(piduser, getenv("USER"));

  readconfig();

  sprintf(ALTERGLGROUP, "%s/%s", glrootpath, GLGROUP);
  if ( (fd = open(ALTERGLGROUP, O_NONBLOCK)) < 0 ) { ALTERGLGROUP[0] = '\0'; close(fd); } 
                                            else close(fd);
  if ( shownormal ) showfile(header);

  if ((shmid = shmget( (key_t)KEY, 0, 0))
       == -1)
    {
     if ( shownormal ) { printf("| Up: %3i / %7.1fkbs | Dn: %3i / %7.1fkbs | Total: %3i / %7.1fkbs |\n", 0, 0.0, 0, 0.0, 0, 0.0);
                        printf("| Currently %2i of %2i users are online...                                |\n",0,MAXUSERS);
                        showfile(footer); } else {
       printf("\002%s\002 is not online!", USERNAME);
      }
      exit(0);
    }

  if ((online = (struct ONLINE *)shmat( shmid, NULL, SHM_RDONLY))
      == (struct ONLINE *)-1)
    {
      fprintf(stdout, "Error: (SHMAT) Failed!\n");
      exit(0);
    }
							     
  shmctl( shmid, IPC_STAT, &ipcbuf);
  num_users = ipcbuf.shm_segsz / sizeof( struct ONLINE );

  numusers = checkusers();
  if ( ! shownormal && ! numusers ) printf("\002%s\002 is not online!", USERNAME);
  if ( shownormal ) { printf("| Up: %3i / %7.1fkbs | Dn: %3i / %7.1fkbs | Total: %3i / %7.1fkbs |\n", ul, ulspeed, dl, dlspeed, ul + dl, ulspeed + dlspeed);
                      printf("| Currently %2i of %2i users are online...                                |\n",numusers,MAXUSERS);
                      showfile(footer);} else printf("\n");
  quit( 0 );
}

static double
calc_time(int pid)
{
  struct timeval tstop;
  double delta, rate;

  if (online[pid].bytes_xfer < 1)
    return 0;
  gettimeofday(&tstop, (struct timezone *)0 );
  delta = ((tstop.tv_sec*10.)+(tstop.tv_usec/100000.)) -
         ((online[pid].tstart.tv_sec*10.)+(online[pid].tstart.tv_usec/100000.));
  delta = delta/10.;
  rate = ((online[pid].bytes_xfer / 1024.0) / (delta));
  if (!rate) rate++;
  return (double)(rate);
}

static void
quit(int exit_status)
{
  shmctl( shmid, IPC_STAT, &ipcbuf);
  if (ipcbuf.shm_nattch <= 1) {
    shmctl( shmid, IPC_RMID, 0);
  }
  shmdt(0);
  exit(exit_status);
}

